# SPDX-FileCopyrightText: Copyright (c) 2024, Linaro Limited.
#
# SPDX-FileCopyrightText: <text>Copyright 2023-2024 Arm Limited and/or its
# affiliates <open-source-office@arm.com></text>
#
# SPDX-License-Identifier: MIT
---
device_type: mps3
job_name: {{ CI_JOB_NAME }}
timeouts:
  job:
    minutes: 240
  actions:
    auto-login-action:
      minutes: 30
  connections:
    auto-login-action:
      minutes: 30
    login-action:
      minutes: 30

metadata:
  source: {{ CI_PROJECT_URL }}
  path: .gitlab/lava/corstone1000-mps3/sanity_job.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

{%- if FREQUENCY == 'adhoc' %}
priority: medium
{%- else %}
priority: low
{%- endif %}
visibility:
  group:
    - cassini

context:
  boot_character_delay: 250
  test_character_delay: 250

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: "{{ LAVA_CALLBACK_TOKEN }}"
      header: "PRIVATE-TOKEN"
      dataset: minimal

actions:

- boot:
    namespace: uart0
    method: new_connection
    connection: uart0

- boot:
    namespace: uart1
    method: new_connection
    connection: uart1

- boot:
    namespace: uart3
    method: new_connection
    connection: uart3

# Booting the mps3 test suite
- deploy:
    to: flasher
    images:
      recovery_image:
        url: "{{ FIRMWARE_ARTIFACT }}"
    namespace: target
    timeout:
      minutes: 5

# Run kernel in Flash to copy rootfs overlay to USB stick
- boot:
    namespace: target
    method: u-boot
    timeout:
      minutes: 30
    commands:
      - run retrieve_kernel_load_addr
      - echo Loading kernel from $kernel_addr to memory ...
      - unzip $kernel_addr 0x90000000
      - loadm 0x90000000 $kernel_addr_r $filesize
      - bootefi $kernel_addr_r $fdtcontroladdr
    parameters:
      kernel-start-message: 'Linux version [0-9]'
    auto_login:
      login_prompt: 'corstone1000-mps3 login:.*'
      username: root
    prompts:
      - '@corstone1000-mps3:.+# '

#
# Fudge to enable bmap-tool usage
#
- deploy:
    namespace: poky
    timeout:
      minutes: 5
    to: usb
    os: oe
    images:
      image:
        url: "{{ UTIL_ARTIFACT }}"
        compression: bz2
    uniquify: false
    device: usb_storage_device
    download:
      tool: /usr/bin/wget
      options: --no-check-certificate -O - {DOWNLOAD_URL}
      prompt: "Connecting to .+"
    writer:
      tool: /bin/tar
      options: -C / -xf -
      prompt: 'writing to stdout'
    tool:
      prompts:
        - 'written to stdout'

#
# Deploy the cassini uefi image stored as artifacts by the build job
#
- deploy:
    namespace: secondary_media
    timeout:
      minutes: 150
    to: usb
    os: oe
    images:
      image:
        url: "{{ IMAGE_ARTIFACT }}"
        compression: gz
      bmap:
        url: "{{ BMAP_ARTIFACT }}"
    uniquify: false
    device: usb_storage_device
    writer:
      tool: /usr/bin/bmaptool
      options: copy {DOWNLOAD_URL} /dev/sda
      prompt: 'bmaptool: info'
    tool:
      prompts: ['copying time: [0-9hms\.\ ]+, copying speed [0-9\.]+ [MK]iB\/sec']

- boot:
    namespace: secondary_media
    method: minimal
    timeout:
      minutes: 30
    parameters:
      kernel-start-message: 'Linux version [0-9]'
    auto_login:
      login_prompt: 'corstone1000-mps3 login:.*'
      username: cassini
      login_commands:
      - cassini123
      - cassini123
    prompts:
      - 'New password: '
      - 'Re-enter new password: '
      - '@corstone1000-mps3:.+\$ '
